import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.IOException;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import org.encog.neural.networks.BasicNetwork;
import org.encog.persist.EncogPersistedCollection;
import org.encog.util.logging.Logging;


public class resilient_network extends JFrame //implements Runnable{
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public static void main(final String args[]) throws IOException {
		Logging.stopConsoleLogging();
		(new resilient_network()).setVisible(true);
		if ((new File("NN_RPROP.eg")).exists()){
			final EncogPersistedCollection encog1 = new EncogPersistedCollection(new File("NN_RPROP.eg"));
			encog1.create();
			network_RPROP=(BasicNetwork) encog1.find("network");
			System.out.println("I initialized network");
		}
		network_RPROP =create_NN.create_RPROP(new File("data_java_short.csv"),5000,0.5,40) ;
		//fc.setCurrentDirectory();
	}

	class Action implements java.awt.event.ActionListener {
		public void actionPerformed(final java.awt.event.ActionEvent event) {
			final Object object = event.getSource();

			if (object == resilient_network.this.open1) {
				open1_actionPerformed(event);
			} else if (object == resilient_network.this.open2) {
				open2_actionPerformed(event);
			} else if (object == resilient_network.this.retrain){
				try {
					retrain_actionPerformed(event);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else if (object == resilient_network.this.recognize){
				try {
					recognize1_actionPerformed(event);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			} else if (object == resilient_network.this.recognize2){
				try {
					recognize2_actionPerformed(event);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

	}

	final static JFileChooser fc = new JFileChooser();
	
	public void open1_actionPerformed(ActionEvent e) {
		//Handle open button action.
		int returnVal = fc.showOpenDialog(this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			//This is where a real application would open the file.
			//log.append("Opening: " + file.getName() + "." + newline);
			this.JLabel1_2.setText(file.getName());
			train_data=file;
		}
	}

	public void open2_actionPerformed(ActionEvent e) {
		//Handle open button action.
		int returnVal = fc.showOpenDialog(this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			//This is where a real application would open the file.
			//log.append("Opening: " + file.getName() + "." + newline);
			this.JLabel1_3.setText(file.getName());
			inputs_data=file;
		}
	}
	
	public void retrain_actionPerformed(ActionEvent e) throws IOException{
		//Handle retrain button action.
		this.JLabel1_4.setText("Trainig Network .......");
		network_RPROP=create_NN.create_RPROP(train_data,15000,0.2,40);
		this.JLabel1_4.setText("Trainig ended succesfully with MSE= "+create_NN.error);
		final EncogPersistedCollection encog = new EncogPersistedCollection(new File("NN_RPROP.eg"));
		encog.create();
		encog.add("network", network_RPROP);
	}
	
	public void recognize1_actionPerformed(ActionEvent e) throws IOException{
		//Handle recognize 1 output button action.
		double[] inputs=new double[5];
		inputs[0]=Double.parseDouble((frames.getValue()).toString());
		inputs[1]=Double.parseDouble((prop1.getValue()).toString());
		inputs[2]=Double.parseDouble((prop2.getValue()).toString());
		inputs[3]=Double.parseDouble((prop3.getValue()).toString());
		inputs[4]=Double.parseDouble((prop4.getValue()).toString());
		output_text.setText(Double.toString(create_NN.round(create_NN.recognize_output(inputs,network_RPROP),2)));
	}
	
	public void recognize2_actionPerformed(ActionEvent e) throws IOException{
		//Handle recognize outputs from file button action.
		JLabel2_4.setText("Computing outputs for inputs in file...");
		create_NN.recognize_file_outputs(inputs_data,save.getText(),network_RPROP);
		JLabel2_4.setText("Successfully ended.");
		
	}

	//budeme updatovat output pri stlaceni tlacidla recognize
	public class Update implements Runnable {
		
		public void run() {
		}
	}

	//vytvorime si zakladnu siet
	public static BasicNetwork network_RPROP ;
	public static File train_data=null;
	public static File inputs_data=null;

	//vytvorime si jednotlive panely v hornom menu
	JTabbedPane tabbedPane = new JTabbedPane();
	ImageIcon icon=null;
	JComponent panel1=new JPanel();
	JComponent panel2=new JPanel();
	JComponent panel3=new JPanel();

	JLabel JLabel1 = new javax.swing.JLabel();
	//private final JLabel JLabel2 = new javax.swing.JLabel();

	//tlacitko na zistenie outputu pre dane parametre
	JButton recognize = new JButton();

	//prvy input siete, pocet framemov
	JLabel JLabel3 = new JLabel("Dlzka zaberu (pocet framov) ");
	JSpinner frames = new JSpinner(new SpinnerNumberModel(130,20,800,1));

	//druhy input siete
	JLabel JLabel4 = new JLabel("Tvar masky 1-4 (1- tvar sa nemeni 4- kazdy frame iny tvar masky) ");
	JSpinner prop1 = new JSpinner(new SpinnerNumberModel(4,1,4,1));

	//treti input siete
	JLabel JLabel5 = new JLabel("Automaticky/Manualny track 1-4 (1- plne automaticka track 4-plne manualny track) ");
	JSpinner prop2 = new JSpinner(new SpinnerNumberModel(4,1,4,1));

	//stvrty input siete
	JLabel JLabel6 = new JLabel("Zmena perspektivy v zabere 1-4 (1-staticky zaber 4- znacna zmena perspektivy) ");
	JSpinner prop3 = new JSpinner(new SpinnerNumberModel(4,1,4,1));

	//piaty input siete
	JLabel JLabel7 = new JLabel("Motion blur 1-4 (1-bez motion bluru 4- velky motion blur) ");
	JSpinner prop4 = new JSpinner(new SpinnerNumberModel(4,1,4,1));

	//piaty input siete
	JLabel JLabel8 = new JLabel("Otput");
	JFormattedTextField output_text= new JFormattedTextField("8h 30min");

	//label so suborom z ktoreho citame data pre panel 2
	JLabel JLabel1_2 = new JLabel("file with data...");

	//open button, dialog na otvorenie suboru s datami pre panel 2
	JButton open1=new JButton();

	//retrain button, pouziva sa na pretrenovanie siete
	JButton retrain=new JButton();

	//label so suborom z ktoreho citame data pre panel 2
	JLabel JLabel1_3 = new JLabel("file with inputs...");
	
	//zobrazuje priebeh trenovania siete
	JLabel JLabel1_4 = new JLabel("");

	//open button, dialog na otvorenie suboru s datami pre panel 2
	JButton open2=new JButton();

	//recognize1 button, pouziva sa na ziskanie otputov do suboru pre cely subor inputov
	JButton recognize2=new JButton();

	//save as, teda textfield na nazov suboru do ktoreho chceme uladat
	JLabel JLabel2_3 = new JLabel("Save outputs as...");
	public static JTextField save= new JTextField("outputs");
	
	//label na ukazovanie stavu recogize file inputs
	JLabel JLabel2_4 = new JLabel("");

	//konstruktor resilient_network
	resilient_network() {

		//zostavime panel1,panel2,panel3 teda naskladame tam vsetky komponenty, po vynulovani layoutu
		this.panel1.setLayout(null);
		this.panel2.setLayout(null);
		this.panel3.setLayout(null);

		setTitle("Java  resilient propagation Neural Network GUI");
		setSize(610, 335);
		setVisible(false);

		//panel1
		this.JLabel1.setText("Parametre pre zistenie outputu: ");
		this.JLabel1.setFont(new Font("sansserif",Font.BOLD,18));
		this.panel1.add(this.JLabel1);
		this.JLabel1.setBounds(12, 12, 330, 20);
		this.panel1.add(this.JLabel3);
		this.JLabel3.setBounds(12, 40, 200, 12);
		this.panel1.add(this.frames);
		this.frames.setBounds(190, 40, 45, 20);
		this.panel1.add(this.JLabel4);
		this.JLabel4.setBounds(12, 70, 400, 12);
		this.panel1.add(this.prop1);
		this.prop1.setBounds(400, 70, 45, 20);
		this.panel1.add(this.JLabel5);
		this.JLabel5.setBounds(12, 100, 500, 12);
		this.panel1.add(this.prop2);
		this.prop2.setBounds(500, 100, 45, 20);
		this.panel1.add(this.JLabel6);
		this.JLabel6.setBounds(12, 130, 485, 12);
		this.panel1.add(this.prop3);
		this.prop3.setBounds(485, 130, 45, 20);
		this.panel1.add(this.JLabel7);
		this.JLabel7.setBounds(12, 160, 350, 12);
		this.panel1.add(this.prop4);
		this.prop4.setBounds(350, 160, 45, 20);
		this.recognize.setText("Recognize");
		this.recognize.setActionCommand("Recognize");
		this.panel1.add(this.recognize);
		this.recognize.setBounds(12, 190, 120, 24);
		this.panel1.add(this.JLabel8);
		this.JLabel8.setBounds(12, 235, 100, 12);
		this.panel1.add(this.output_text);
		this.output_text.setBounds(65, 229, 80, 24);
		this.output_text.setEditable(false);
		this.output_text.setForeground(Color.red);
		this.output_text.setFont(new Font("sansserif",Font.BOLD,12));
		final Action bAction = new Action();
		this.recognize.addActionListener(bAction);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);

		//panel2
		this.panel2.add(this.JLabel1_2);
		this.JLabel1_2.setBounds(20, 20, 100, 12);
		this.open1.setText("Open");
		this.open1.setActionCommand("Open1");
		this.panel2.add(this.open1);
		this.open1.setBounds(150, 14, 70, 24);
		this.open1.addActionListener(bAction);
		this.retrain.setText("Retrain");
		this.retrain.setActionCommand("Retrain");
		this.panel2.add(this.retrain);
		this.retrain.setBounds(20, 70, 120, 24);
		this.retrain.addActionListener(bAction);
		this.panel2.add(this.JLabel1_4);
		this.JLabel1_4.setBounds(20, 150, 450, 12);

		//panel3
		this.panel3.add(this.JLabel1_3);
		this.JLabel1_3.setBounds(20, 20, 100, 15);
		this.open2.setText("Open");
		this.open2.setActionCommand("Open2");
		this.panel3.add(this.open2);
		this.open2.setBounds(150, 14, 70, 24);
		this.open2.addActionListener(bAction);
		this.panel3.add(this.JLabel2_3);
		this.JLabel2_3.setBounds(20, 56, 140, 12);
		this.panel3.add(resilient_network.save);
		resilient_network.save.setBounds(150, 50, 90, 24);
		this.recognize2.setText("Recognize");
		this.recognize2.setActionCommand("Recognize2");
		this.panel3.add(this.recognize2);
		this.recognize2.setBounds(20, 90, 120, 24);
		this.recognize2.addActionListener(bAction);
		this.panel3.add(this.JLabel2_4);
		this.JLabel2_4.setBounds(20, 150, 240, 14);


		this.tabbedPane.addTab("Recognize output",icon, this.panel1,"Recognizes output for given input parameters");
		this.tabbedPane.setMnemonicAt(0, KeyEvent.VK_1);
		this.tabbedPane.addTab("Load and retrain",icon, this.panel2,"Load and retrain NN with new data");
		this.tabbedPane.setMnemonicAt(1, KeyEvent.VK_2);
		this.tabbedPane.addTab("Recognize outputs file",icon, this.panel3,"Recognizes outputs from inputs in file and writes to file");
		this.tabbedPane.setMnemonicAt(2, KeyEvent.VK_3);
		getContentPane().add(this.tabbedPane); 

	}

}
